package apis

import (
	"fmt"

	"github.com/gin-gonic/gin"
	"github.com/gin-gonic/gin/binding"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineApiUser struct {
	api.Api
}

// GetPage 获取api用户管理列表
// @Summary 获取api用户管理列表
// @Description 获取api用户管理列表
// @Tags api用户管理
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineApiUser}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-api-user [get]
// @Security Bearer
func (e LineApiUser) GetPage(c *gin.Context) {
	req := dto.LineApiUserGetPageReq{}
	s := service.LineApiUser{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req, binding.Form, binding.Query).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineApiUser, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取api用户管理失败，\r\n失败信息 %s", err.Error()))
		return
	}

	// for i, apiUser := range list {
	// 	if apiUser.UserId <= 0 {
	// 		list[i].OpenStatus = 1
	// 	}
	// }

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取api用户管理
// @Summary 获取api用户管理
// @Description 获取api用户管理
// @Tags api用户管理
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineApiUser} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-api-user/{id} [get]
// @Security Bearer
func (e LineApiUser) Get(c *gin.Context) {
	req := dto.LineApiUserGetReq{}
	s := service.LineApiUser{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineApiUser

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取api用户管理失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(object, "查询成功")
}

// Insert 创建api用户管理
// @Summary 创建api用户管理
// @Description 创建api用户管理
// @Tags api用户管理
// @Accept application/json
// @Product application/json
// @Param data body dto.LineApiUserInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-api-user [post]
// @Security Bearer
func (e LineApiUser) Insert(c *gin.Context) {
	req := dto.LineApiUserInsertReq{}
	s := service.LineApiUser{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建api用户管理失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改api用户管理
// @Summary 修改api用户管理
// @Description 修改api用户管理
// @Tags api用户管理
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineApiUserUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-api-user/{id} [put]
// @Security Bearer
func (e LineApiUser) Update(c *gin.Context) {
	req := dto.LineApiUserUpdateReq{}
	s := service.LineApiUser{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改api用户管理失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "修改成功")
}

// Delete 删除api用户管理
// @Summary 删除api用户管理
// @Description 删除api用户管理
// @Tags api用户管理
// @Param data body dto.LineApiUserDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-api-user [delete]
// @Security Bearer
func (e LineApiUser) Delete(c *gin.Context) {
	s := service.LineApiUser{}
	req := dto.LineApiUserDeleteReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除api用户管理失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "删除成功")
}

func (e LineApiUser) Bind(c *gin.Context) {
	s := service.LineApiUser{}
	req := dto.LineApiUserBindSubordinateReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)

	err = s.Bind(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("绑定api用户关系失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(nil, "操作成功")
}

func (e LineApiUser) GetUser(c *gin.Context) {
	s := service.LineApiUser{}
	req := dto.LineApiUserBindSubordinateReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	//p := actions.GetPermissionFromContext(c)
	list := make([]models.LineApiUser, 0)
	err = s.GetUser(&req, &list)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(list, "操作成功")
}

// GetMainUser 获取主账号
func (e LineApiUser) GetMainUser(c *gin.Context) {
	s := service.LineApiUser{}
	req := dto.GetMainUserReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	//p := actions.GetPermissionFromContext(c)
	list := make([]models.LineApiUser, 0)
	err = s.GetMainUser(&req, &list)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(list, "操作成功")
}
